/*
    S60Bible A Bible Reader for SymbianOS
    Copyright (C) 2004 Yohanes Nugroho

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Yohanes Nugroho (yohanes@opensource.or.id)
    Kp Areman RT 09/08 No 71 Desa Tugu Cimanggis Depok 16951 Indonesia
*/


/*
 * Filename: S60BibleApplication.cpp
 * Description: Bible Application Class
 * Author: Yohanes Nugroho
 * Creation Date:
 * Last Update: 15/Feb/2004
 * Revisions:
 */

#include "S60BibleDocument.h"
#include "S60BibleApplication.h"

// local constants
#ifdef __SERIES60_30__
const TUid KUidS60BibleApp = {0xF0201077};
const TUid KUidS60BibleUi = {0xF0201079};
#else
const TUid KUidS60BibleApp = {0x10201077};
const TUid KUidS60BibleUi = {0x10201079};
#endif

CApaDocument* CS60BibleApplication::CreateDocumentL()
{
	// Create an S60Bible document, and return a pointer to it
RDebug::Print(_L("S60Bible: Creating document"));
	CApaDocument* document = CS60BibleDocument::NewL(*this);
RDebug::Print(_L("S60Bible: Done"));
	return document;
}

TUid CS60BibleApplication::AppDllUid() const
{
	// Return the UID for the S60Bible application
	RDebug::Print(_L("S60Bible: AppDLL"));	
	return KUidS60BibleApp;
}

TUid CS60BibleApplication::AppUiUid() const
{
	// Return the UID for the Ui
	RDebug::Print(_L("S60Bible: AppUI"));
	return KUidS60BibleUi;
}

