/*
    S60Bible A Bible Reader for SymbianOS
    Copyright (C) 2004 Yohanes Nugroho

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Yohanes Nugroho (yohanes@opensource.or.id)
    Kp Areman RT 09/08 No 71 Desa Tugu Cimanggis Depok 16951 Indonesia
*/


/*
 * Filename: S60BibleDocument.cpp
 * Description: Bible Document Class
 * Author: Yohanes Nugroho
 * Creation Date:
 * Last Update: 15/Feb/2004
 * Revisions:
 */


#include "S60BibleAppUi.h"
#include "S60BibleDocument.h"
#include "S60BibleApplication.h"
#include <S60Bible.rsg>
#include <avkon.hrh>
#include "S60Bible.pan"
#include "S60Bible.hrh"
#include "log.h"

CS60BibleDocument* CS60BibleDocument::NewLC(CEikApplication& aApp)
{
	CS60BibleDocument* self = new (ELeave) CS60BibleDocument(aApp);
	CleanupStack::PushL(self);
	self->ConstructL();
	return self;
}

CS60BibleDocument* CS60BibleDocument::NewL(CEikApplication& aApp)
{
	CS60BibleDocument* self = NewLC(aApp);
	CleanupStack::Pop(self);
	return self;
}


void CS60BibleDocument::ConstructL()
{
	//CEikonEnv::Static()->DisableExitChecks(ETrue);

	iViewer = new Viewer();
	iViewer->ConstructL(CEikonEnv::Static()->FsSession());
}

CS60BibleDocument::~CS60BibleDocument()
{
	delete iViewer;
}

CS60BibleDocument::CS60BibleDocument(CEikApplication& aApp)
:	CEikDocument(aApp)
{
	//	No implementation required
}

CEikAppUi* CS60BibleDocument::CreateAppUiL()
{
	// Create the application user interface, and return a pointer to it
	//Log(_L("Create app UI"));
	CEikAppUi* appUi = new (ELeave) CS60BibleAppUi(this);
	return appUi;
}


Viewer* CS60BibleDocument::Model()
{
	return iViewer;
}

