/*
* ============================================================================
*  Name     : S80BibleDocument.cpp
*  Part of  : S80Bible
*  Created  : 22.05.2006 by Yohanes Nugroho
*  Description:
*     CS80BibleDocument implementation
*  Copyright: 
* ============================================================================
*/


#include <txtrich.h>
#include <eikenv.h>   // CEikEnv
#include <cknenv.h>   // CknEnv

#include "S80BibleAppUi.h"
#include "S80BibleDocument.h"
#include "Viewer.h"

// Standard Symbian OS construction sequence
CS80BibleDocument* CS80BibleDocument::NewL(CEikApplication& aApp)
    {
    CS80BibleDocument* self = NewLC(aApp);
    CleanupStack::Pop(self);
    return self;
    }

CS80BibleDocument* CS80BibleDocument::NewLC(CEikApplication& aApp)
    {
    CS80BibleDocument* self = new (ELeave) CS80BibleDocument(aApp);
    CleanupStack::PushL(self);
    self->ConstructL();
    return self;
    }

void CS80BibleDocument::ConstructL()
    {
	iViewer = new Viewer();
	iViewer->ConstructL(CEikonEnv::Static()->FsSession());
    }    

CS80BibleDocument::CS80BibleDocument(CEikApplication& aApp) : CEikDocument(aApp) 
    {
	// no implementation required
    }

CS80BibleDocument::~CS80BibleDocument()
    {
		delete iViewer;
		iViewer = NULL;
    }

CEikAppUi* CS80BibleDocument::CreateAppUiL()
    {
    // Create the application user interface, and return a pointer to it,
    // the framework takes ownership of this object
    CEikAppUi* appUi = new (ELeave) CS80BibleAppUi(this);
    return appUi;
    }

Viewer* CS80BibleDocument::Model()
{
	return iViewer;
}