/* Copyright (c) 2003, Nokia Mobile Phones. All rights reserved */

#include <eikgted.h> 
#include <eikseced.h> 
#include <eikenv.h>
#include <e32base.h>
#include <eikchlst.h>
#include <eiktxlbm.h>

#include "S80Bible.hrh"
#include "S80Bible.rsg"
#include "S80BibleAppUi.h"
#include "S80BibleDocument.h"
#include "CStringList.h"
#include "Viewer.h"
#include "bookmarkdialog.h"

// Constructor
CBookmarkDialog::CBookmarkDialog(TInt &aIndex)
{
	iIndex = &aIndex;
}

void CBookmarkDialog::SetList(CDesCArray * aList)
{
	iStrings = aList;
}

// Preset fields prior to dialog display
void CBookmarkDialog::PreLayoutDynInitL()
{
	iListBox=(CEikTextListBox*)Control(EBibleListID);
	iListBox->Model()->SetItemTextArray(iStrings);
	iListBox->Model()->SetOwnershipType(ELbmDoesNotOwnItemArray);
	if (*iIndex<0 || *iIndex>=iStrings->MdcaCount()) {
		*iIndex = 0;
	}
	iListBox->SetCurrentItemIndex(*iIndex);
	iListBox->CreateScrollBarFrameL();
	iListBox->ScrollBarFrame()->SetScrollBarVisibilityL(CEikScrollBarFrame::EAuto,CEikScrollBarFrame::EAuto);
}


// Extract text from dialog
TBool CBookmarkDialog::OkToExitL(TInt  aKey )
{
    //CCoeControl* myControlPtr = this->Control(ES80BibleList);
    //CEikChoiceList* mychoicelist = static_cast<CEikChoiceList*>(myControlPtr);
	
	//*iIndex = mychoicelist->CurrentItem();
	if (aKey==EEikBidDel) {
		if (iListBox->CurrentItemIndex()<0) return EFalse;
		CS80BibleAppUi *appui = static_cast<CS80BibleAppUi *>(CEikonEnv::Static()->AppUi());
		CS80BibleDocument  *document = appui->Document();
		document->Model()->DelBookmark(iListBox->CurrentItemIndex());
		document->Model()->SaveBookmarkL();
		iListBox->SetCurrentItemIndex(0);
		iListBox->HandleItemRemovalL();
		iListBox->SetCurrentItemIndexAndDraw(0);		
		return EFalse;
	}

	*iIndex = ListBoxCurrentItem(EBibleListID);
    return ETrue;
}
