/*
    S60Bible A Bible Reader for SymbianOS
    Copyright (C) 2004 Yohanes Nugroho

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Yohanes Nugroho (yohanes@opensource.or.id)
    Kp Areman RT 09/08 No 71 Desa Tugu Cimanggis Depok 16951 Indonesia
*/


#ifndef __BOOKLIST_CONTAINER_H__
#define __BOOKLIST_CONTAINER_H__

#include <aknview.h>
#include <coecntrl.h>
#include <eiktxlbx.h>
#include <eiklbi.h>
#include <eiklbv.h>
#include <eiktxlbm.h>
#include <eiktxlbx.h>
#include <aknsfld.h>
#include <aknutils.h>
#include <aknlists.h>
#include <badesca.h>
#include <aknsfld.h> 

class CS60BibleDocument;

class CBookListContainer : public CCoeControl, MCoeControlObserver, MEikListBoxObserver
    {
public:
	~CBookListContainer();
/*!
  @function NewL

  @discussion Create a CMultiViewsContainer1 object, which will draw itself to aRect
  @param aRect the rectangle this view will be drawn to
  @result a pointer to the created instance of CMultiViewsContainer1
*/
    static CBookListContainer * NewL(CAknView *aView, CS60BibleDocument* aDocument);

/*!
  @function NewLC

  @discussion Create a CMultiViewsContainer1 object, which will draw itself to aRect
  @param aRect the rectangle this view will be drawn to
  @result a pointer to the created instance of CMultiViewsContainer1
*/
    static CBookListContainer * NewLC(CAknView *aView, CS60BibleDocument* aDocument);

/*!
  @fuction ConstructL

  @discussion Perform the second phase construction of a CMultiViewsContainer1 object
  @param aRect Frame rectangle for container.
*/
    void ConstructL(CAknView *aView, CS60BibleDocument* aDocument);

#ifdef __SERIES60_30__
void HandleResourceChange(TInt aType);
#endif

public: // from CoeControl
	void HandleControlEventL(CCoeControl* aControl,TCoeEvent aEventType);
	void SizeChanged();
    	TKeyResponse OfferKeyEventL(const TKeyEvent& aKeyEvent, TEventCode aType);

	void HandleListBoxEventL(CEikListBox* /*aListBox*/,
    		TListBoxEvent aEventType );
    	void GotoBook();
	CAknSearchField* CreateFindBoxL(CEikListBox* aListBox, CTextListBoxModel* aModel,
    	CAknSearchField::TSearchFieldStyle aStyle );

/*!
  @function CountComponentControls

  @discussion Get the number of controls contained in this compound control
  @return Number of component controls
*/
    TInt CountComponentControls() const;

/*!
  @function ComponentControl.

  @discussion Get the specified component
  @param aIndex specification for component pointer
  @return Pointer to component control
*/
    CCoeControl* ComponentControl(TInt aIndex) const;

/*!
  @function Draw

  @discussion Draw this CMultiViewsContainer1 to the screen
  @param aRect the rectangle of this view that needs updating
*/
    void Draw(const TRect& aRect) const;

	TKeyResponse CBookListContainer::CustomFindOfferKeyEventL(const TKeyEvent& aKeyEvent, 
		TEventCode aType, 
		CCoeControl* /*aListBoxParent*/, 
		CEikListBox* /*aListBox*/, 
		CAknSearchField* /*aSearchField*/, 
		TBool /*isFindPopup*/, TBool &aNeedRefresh);
	
	void QueryBookList(TDesC& aQueryFrag,TBool aWider);


    CS60BibleDocument* iDocument;

    //TKeyResponse CS60BibleMainContainer::OfferKeyEventL(const TKeyEvent& aKeyEvent, TEventCode aType);
    //TCoeInputCapabilities CS60BibleMainContainer::InputCapabilities() const;
    //CEikButtonGroupContainer* iCba;
    //TBool iFullScreen;
    //void SetFullScreenL(TBool aFullScreen);
    //void ToggleFullScreen();
    	CAknView *iView;
	CEikFormattedCellListBox* iListBox;
	CDesCArray*       iTextArray;
	CDesCArray*       iMatchedArray;
	CAknSearchField* iFindBox;
    };

#endif
